﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Experimental.U2D.Animation;
using UnityEngine.UI;

namespace CharacterGenerator
{
    public class SwitchBodyPart : MonoBehaviour
    {
        [SerializeField] private CharacterGraphics characterGraphics;
        [SerializeField] private string[] categories;

        [SerializeField] private Button nextButton;
        [SerializeField] private Button previousButton;

        private int currentIndex;

        private void Awake()
        {
            nextButton.onClick.AddListener((() => ChangeVariation(1)));
            previousButton.onClick.AddListener((() => ChangeVariation(-1)));

            characterGraphics.OnAllPartsSwitched += OnPresetApplied;
        }

        private void ChangeVariation(int delta)
        {
            currentIndex += delta;
            currentIndex %= characterGraphics.labels.Length;
            currentIndex = currentIndex < 0 ? characterGraphics.labels.Length - 1 : currentIndex;

            characterGraphics.SwitchParts(categories, currentIndex);
        }

        private void OnPresetApplied(string label, int labelIndex)
        {
            currentIndex = labelIndex;
        }
    }
}